
#ifndef __GRID__
#define __GRID__

#include <crtdbg.h>
#include "stdafx.h"
#include <stdlib.h>

#define MAX_GRID_ALLOC 32


#define random(num)(int)(((long)rand()*(num))/(RAND_MAX+1))


//PROPOSAL:
// typedef int int_Owner;
// INSTEAD OF 'en_LineAttr'
enum en_LineAttr { UNCHECKED=0, PLAYER1=1, PLAYER2=2, NODE=3, LINE=4 };
//#define  NODE 3

enum en_LineDir { NONE=0, RIGHT=1, DOWN=2 };




class CMCell {
  public:
	en_LineAttr  right;
	en_LineAttr  down;
	en_LineAttr  owner;

	CMCell(): right(UNCHECKED), down(UNCHECKED), owner(UNCHECKED) {}
	void operator = (CMCell& cell) {right=cell.right;  down=cell.down; owner=cell.owner; }
	void Clear(void) { right = down = owner = UNCHECKED; }
};




struct st_count {
	int zeros;
	int ones;
	int twos;
	int threes;
	int fours;
};


struct st_WinningCount {
	int p[4];   ////////////////// not very nice
	
};


class CMLine {

  public:
	int x;
	int y;
	en_LineDir dir;

  public:
	CMLine() {}
	CMLine(int x0, int y0, en_LineDir dir0): x(x0), y(y0), dir(dir0) {}
	CMLine(CMLine& line) {ASSERT(0);}

	CMLine& operator = (const CMLine& line) {x=line.x; y=line.y; dir=line.dir; return *this;}
};




class CMGrid {
	
  public:
	void GetMakeFour(CMLine *fourth_line);
	void GetWhosWinning(st_WinningCount *wc);
	int DoCompletedCells(int current_player);
	BOOL AreAllCellsChecked(void);
	
	CMCell cell[MAX_GRID_ALLOC][MAX_GRID_ALLOC];
  
  private:	

	int width;    // number of elements in a row
	int height;   // number of elements in a column

  public:

	CMGrid(void) {}
	~CMGrid(void) {}
	CMGrid(CMGrid& grid) { ASSERT(0); }

	void Clear(void);
	void operator = (CMGrid& grid);

	void SetLine(CMLine& line, en_LineAttr attr);
	BOOL IsLineSet(CMLine& line);
	
	void GetCount(st_count* count);
	BOOL AnyMakeFour();
	int GetCheckedSides(int x, int y);

	void SetWidth(int w_cells) { width=w_cells; if(width > MAX_GRID_ALLOC-1) width=MAX_GRID_ALLOC-1; }
	void SetHeight(int h_cells) { height=h_cells; if(height > MAX_GRID_ALLOC-1) height=MAX_GRID_ALLOC-1; }
	int GetWidth(void) { return width; }
	int GetHeight(void) { return height; }


};




#endif // __GRID__