// LinesDoc.h : interface of the CLinesDoc class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef __LINESDOC__
#define __LINESDOC__

#include "Grid.h"

enum en_PlayerType { HUMAN=1, COMPUTER=0 };

#define MAX_PLAYERS 5

class CLinesDoc : public CDocument
{
protected: // create from serialization only
	CLinesDoc();
	DECLARE_DYNCREATE(CLinesDoc)

// Attributes
public:
	void DisplayScore();
	float m_fCursorVel;
	void MoveCursorInit(void);
	BOOL MoveCursorTick(CMLine &target_line);
	void ComputerDecide(CMLine *chosen_line);
	void ComputerTurnTick(void);
	void NextPlayer(CMLine& lineLastSelection);
	void HeartBeat(void);
	void MoveMouse(CPoint to_point);
	CString GetHumanLooseComment(int looser, float fVictoryRate);

	CMGrid        grid;

	BOOL game_is_on;
	BOOL game_just_finished;

	int n_players;
	int current_player;   // 1,2,3,4...
	BOOL again;

	en_PlayerType player_type[MAX_PLAYERS];  // human/computer


	// Computer Moving Mouse Variables:
	float  m_fSpiralFactorX;
	float  m_fSpiralFactorY;
	CMLine m_lineLastSelection;
	BOOL   m_bGoingToLine;
	BOOL   m_bDecided;







// Operations
public:
	static CLinesDoc * GetDoc();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLinesDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CLinesDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CLinesDoc)
	afx_msg void OnOptions();
	afx_msg void OnGameAbort();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////



#endif
