// LinesView.cpp : implementation of the CLinesView class
//

#include "stdafx.h"
#include "Lines.h"

#include "LinesDoc.h"
#include "LinesVie.h"

#include "MColorDl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
    
/////////////////////////////////////////////////////////////////////////////
// CLinesView

IMPLEMENT_DYNCREATE(CLinesView, CView)

BEGIN_MESSAGE_MAP(CLinesView, CView)
	//{{AFX_MSG_MAP(CLinesView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_KEYDOWN()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLinesView construction/destruction

CLinesView::CLinesView()
{


	// A better way to load the cursor resource is to call
	// CWinApp::LoadCursor
	hCursorP1 = AfxGetApp()->LoadCursor(IDC_P1);  
	hCursorP2 = AfxGetApp()->LoadCursor(IDC_P2);  
	hCursorP1Again = AfxGetApp()->LoadCursor(IDC_P1_AGAIN);  
	hCursorP2Again = AfxGetApp()->LoadCursor(IDC_P2_AGAIN);  

	if(!LoadINIFile()) {
		AfxGetMainWnd()->MessageBox("ERROR Reading .INI file. Reseting to default values.");
		InitDefaultColors();
		WriteINIFile();
	}


}

CLinesView::~CLinesView()
{
}


/////////////////////////////////////////////////////////////////////////////
// CLinesView drawing

void CLinesView::OnDraw(CDC* pDC)
{
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CWinApp* pApp = AfxGetApp();


	
	
	
	/*
	// Get the invalidated rectangle of the view, or in the case
	// of printing, the clipping region of the printer dc.
	CRect rectClip;
	CRect rectStroke;
	pDC->GetClipBox(&rectClip);
	pDC->LPtoDP(&rectClip);
	rectClip.InflateRect(1, 1); // avoid rounding to nothing
	*/

	int m_nPenWidth = 3;

	CPen      penLine[5];
	CBrush    brushRect;

	ASSERT(UNCHECKED==0);
	ASSERT(PLAYER1==1);
	ASSERT(PLAYER2==2);
	ASSERT(NODE==3);
	ASSERT(LINE==4);

	if (!penLine[UNCHECKED].CreatePen(PS_SOLID, m_nPenWidth, pDC->GetNearestColor(color.unchecked))) return;
	if (!penLine[PLAYER1].CreatePen(PS_SOLID, m_nPenWidth, pDC->GetNearestColor(color.player1))) return;
	if (!penLine[PLAYER2].CreatePen(PS_SOLID, m_nPenWidth, pDC->GetNearestColor(color.player2))) return;
	if (!penLine[NODE].CreatePen(PS_SOLID, 1, pDC->GetNearestColor(color.node_frame))) return;
	if (!penLine[LINE].CreatePen(PS_SOLID, m_nPenWidth, pDC->GetNearestColor(color.line))) return;

	if(!brushRect.CreateSolidBrush(pDC->GetNearestColor(color.node_fill))) return;
	
	CBrush* pOldBrush = pDC->SelectObject(& brushRect);
	CPen* pOldPen = pDC->SelectObject(& penLine[UNCHECKED]);

	int x1,y1, x2,y2;

	for(int y=0; y<pDoc->grid.GetHeight()+1; y++) {
		for(int x=0; x<pDoc->grid.GetWidth()+1; x++) {
			
			x1 = grid_ox + x*cell_dx;
			y1 = grid_oy + y*cell_dy;

			x2 = x1 + cell_dx;
			y2 = y1 + cell_dy;


			// LINE
			// line right
			if(x<pDoc->grid.GetWidth()) {   // not the right_lines at the right side of the grid
				//ASSERT(pDoc->grid.cell[x][y].right>=0 && pDoc->grid.cell[x][y].right<=2);
				if(pDoc->grid.cell[x][y].right==UNCHECKED) pDC->SelectObject(& penLine[UNCHECKED]);
				else pDC->SelectObject(& penLine[LINE]);
				pDC->MoveTo(x1+node_dx/2+1,y1);
				pDC->LineTo(x2-node_dx/2-2,y1);
			}

			// line down
			if(y<pDoc->grid.GetHeight()) {   // not the down_lines at the right side of the grid
				//ASSERT(pDoc->grid.cell[x][y].down>=0 && pDoc->grid.cell[x][y].down<=2);
				if(pDoc->grid.cell[x][y].down==UNCHECKED) pDC->SelectObject(& penLine[UNCHECKED]);
				else pDC->SelectObject(& penLine[LINE]);
				pDC->MoveTo(x1,y1+node_dy/2+1);
				pDC->LineTo(x1,y2-node_dy/2-2);
				
			}
		

			// RECTANGLES
			pDC->SelectObject(& penLine[NODE]);
			pDC->Rectangle(
				x1 - node_dx/2, y1 - node_dy/2,				
				x1 + node_dx/2, y1 + node_dy/2);

			// draw X's and O's in cells 
			if(x<pDoc->grid.GetWidth() && y<pDoc->grid.GetHeight()) {
				if(pDoc->grid.cell[x][y].owner != UNCHECKED) {				
					pDC->SelectObject(& penLine[pDoc->grid.cell[x][y].owner]);
						
					pDC->MoveTo(x1+cell_dx/6, y1+cell_dy/6);
					pDC->LineTo(x2-cell_dx/6, y2-cell_dy/6);
	
					pDC->MoveTo(x1+cell_dx/6, y2-cell_dy/6);
					pDC->LineTo(x2-cell_dx/6, y1+cell_dy/6);
				}
				
			}
				


		

		}

	}








	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);

}

/////////////////////////////////////////////////////////////////////////////
// CLinesView diagnostics

#ifdef _DEBUG
void CLinesView::AssertValid() const
{
	CView::AssertValid();
}

void CLinesView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CLinesDoc* CLinesView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLinesDoc)));
	return (CLinesDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLinesView message handlers

void CLinesView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CView::OnMouseMove(nFlags, point);
}

void CLinesView::OnLButtonUp(UINT nFlags, CPoint point) 
{

	

	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->player_type[pDoc->current_player] == HUMAN) {

		CMLine line;
		GetPointedLine(point, &line);
	
		if(line.dir!=NONE) {
			if(pDoc->grid.IsLineSet(line) == FALSE) {
				Invalidate(0);
				pDoc->grid.SetLine(line, (en_LineAttr) pDoc->current_player);
				pDoc->NextPlayer(line);
			}
		}

	}

	CView::OnLButtonUp(nFlags, point);

}





void CLinesView::OnSize(UINT nType, int cx, int cy) {
	
	// TODO: Add your message handler code here
	CalcSize(cx,cy);

	CView::OnSize(nType, cx, cy);
	
}

BOOL CLinesView::OnEraseBkgnd(CDC* pDC) {

	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	near_color.background = pDC->GetNearestColor(color.background);

	CBrush backBrush(pDC->GetNearestColor(color.background));
 
	// Save old brush
	CBrush* pOldBrush = pDC->SelectObject(&backBrush);
 
	CRect rect;
	pDC->GetClipBox(&rect);     // Erase the area needed
 
	pDC->PatBlt(rect.left, rect.top, 
				rect.Width(),rect.Height(), PATCOPY);
	
	// Restore old brush
	pDC->SelectObject(pOldBrush);
	
	return TRUE;
     
	//return CView::OnEraseBkgnd(pDC);
}

void CLinesView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
//	SetCursor(hCursorP1);
	// if(nChar == 0x1b) 
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CLinesView::GetPointedLine(CPoint point, CMLine *line) { 
						 
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	line->x = 0; 
	line->y = 0;
	line->dir = NONE;

	int x1,y1, 
		xr,yd;

	for(int y=0; y<pDoc->grid.GetHeight()+1; y++) {
		for(int x=0; x<pDoc->grid.GetWidth()+1; x++) {
			
			x1 = grid_ox + x*cell_dx;
			y1 = grid_oy + y*cell_dy;

			xr = x1 + cell_dx/2;
			yd = y1 + cell_dy/2;

			// line right
			if(x<pDoc->grid.GetWidth()) {   // not the right_lines at the right side of the grid
				if( xr-cell_dx/3 < point.x && 
					point.x      < xr+cell_dx/3 &&
					y1-cell_dy/3 < point.y && 
					point.y      < y1+cell_dx/3) {

						//pDoc->cell[x][y].right =(en_LineAttr) !pDoc->cell[x][y].right;
						line->x = x;
						line->y = y; 
						line->dir = RIGHT;
						return;
				}

			}

			// line down
			if(y<pDoc->grid.GetHeight()) {   // not the down_lines at the right side of the grid
				if( x1-cell_dx/3 < point.x && 
					point.x      < x1+cell_dx/3 &&
					yd-cell_dy/3 < point.y && 
					point.y      < yd+cell_dx/3) {

						//pDoc->cell[x][y].down =(en_LineAttr) !pDoc->cell[x][y].down;
						line->x = x;
						line->y = y; 
						line->dir = DOWN;
						return;
				}
			}
		

		}

	
	}

}


/*
int CLinesView::GetCheckedSides(CPoint point) {

	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	ASSERT(point.x>=0 && point.x<pDoc->grid.GetWidth()-1);
	ASSERT(point.y>=0 && point.y<pDoc->grid.GetHeight()-1);

	return (pDoc->grid.cell[point.x][point.y].right   != UNCHECKED ? 1:0) +
		   (pDoc->grid.cell[point.x][point.y].down    != UNCHECKED ? 1:0) +
		   (pDoc->cell[point.x+1][point.y].down  != UNCHECKED ? 1:0) +
		   (pDoc->cell[point.x][point.y+1].right != UNCHECKED ? 1:0);
}
*/




void CLinesView::OnInitialUpdate() {
	
	RECT rect;
	GetClientRect(&rect);
	OnSize(0,rect.right, rect.bottom);

	CView::OnInitialUpdate();
	
}

BOOL CLinesView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	if(pDoc->current_player) {
		SetMyCursor();
	}
	else return CView::OnSetCursor(pWnd, nHitTest, message);

	return 0;

}


   // View implementation file
CLinesView * CLinesView::GetView() {

	CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);

	CView * pView = pFrame->GetActiveView();
 
	if ( !pView ) 
		return NULL;
 
	// Fail if view is of wrong kind
	// (this could occur with splitter windows, or additional
	// views on a single document
	if ( ! pView->IsKindOf( RUNTIME_CLASS(CLinesView) ) )
		return NULL;
 
	return (CLinesView *) pView;
}






void CLinesView::GetLineCoord(CMLine& line, CPoint * point) {

	point->x = grid_ox + line.x * cell_dx;
	point->y = grid_oy + line.y * cell_dy;

	if(line.dir == RIGHT) point->x += cell_dx/2;
	else if(line.dir == DOWN) point->y += cell_dy/2;
	else ASSERT(0);


}





BOOL CLinesView::LoadINIFile(void) {

	char *stopstring;
#define HEX_STRING_TO_COLORREF(string) ((COLORREF) strtol(string, &stopstring, 16))


	CWinApp* pApp = AfxGetApp();
	ASSERT(pApp);
 
	CString strSection = "Colors";
	CString strValue;
	
	strValue = pApp->GetProfileString(strSection, "Background");
	if(strValue.IsEmpty()) return FALSE;
	color.background = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "Unchecked");
	if(strValue.IsEmpty()) return FALSE;
	color.unchecked = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "Line");
	if(strValue.IsEmpty()) return FALSE;
	color.line = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "PLayer1");
	if(strValue.IsEmpty()) return FALSE;
	color.player1 = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "PLayer2");
	if(strValue.IsEmpty()) return FALSE;
	color.player2 = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "Node Frame");
	if(strValue.IsEmpty()) return FALSE;
	color.node_frame = HEX_STRING_TO_COLORREF(strValue);

	strValue = pApp->GetProfileString(strSection, "Node Fill");
	if(strValue.IsEmpty()) return FALSE;
	color.node_fill = HEX_STRING_TO_COLORREF(strValue);

	
	return TRUE;

}


void CLinesView::WriteINIFile(void) {

	#define COLORREF_TO_HEX_CSTRING(cstring, colorref) \
		cstring.Format("%lX", (long)colorref);

	CWinApp* pApp = AfxGetApp();
	ASSERT(pApp);

	char strSection[] = "Colors";
	CString strValue;
	
	
	COLORREF_TO_HEX_CSTRING(strValue, color.background);
	pApp->WriteProfileString(strSection, "Background", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.unchecked);
	pApp->WriteProfileString(strSection, "Unchecked", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.line);
	pApp->WriteProfileString(strSection, "Line", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.player1);
	pApp->WriteProfileString(strSection, "Player1", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.player2);
	pApp->WriteProfileString(strSection, "Player2", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.node_frame);
	pApp->WriteProfileString(strSection, "Node Frame", strValue);

	COLORREF_TO_HEX_CSTRING(strValue, color.node_fill);
	pApp->WriteProfileString(strSection, "Node Fill", strValue);



}






void CLinesView::InitDefaultColors(void) {
	color.background = 0x960000;
	color.unchecked  = 0x962828;
	color.player2    = 0xFF;
	color.player1    = 0xFF00;
	color.node_frame = 0xFFFF00;
	color.node_fill  = 0xFF0000;
	color.line       = 0xFFFF;
/*
	color.background = RGB(0,0,150);
	color.unchecked  = RGB(40,40,150);
	color.line       = RGB(255,255,255);
	color.player1    = RGB(255,0,0);
	color.player2    = RGB(0,255,0);
	color.node_frame = RGB(200,160,160);
	color.node_fill  = RGB(200,100,100);

*/
}

void CLinesView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->game_is_on && pDoc->player_type[1]==COMPUTER && pDoc->player_type[2]==COMPUTER) {

		int result = AfxGetMainWnd()->MessageBox("Continue with the game?", "Lines", MB_ICONSTOP|MB_YESNO|MB_APPLMODAL);
		if(result == IDNO) {
			pDoc->game_is_on = FALSE;
		}



	}

	CView::OnLButtonDown(nFlags, point);
}




void CLinesView::SetMyCursor(void) {
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	switch(pDoc->current_player) {
	  case PLAYER1: 
		  if(pDoc->again) SetCursor(hCursorP1Again); 
		  else SetCursor(hCursorP1); 
		  break;
	  case PLAYER2: 
		  if(pDoc->again) SetCursor(hCursorP2Again); 
		  else SetCursor(hCursorP2); 
		  break;
	  default:
		  //SetCursor(IDC_ARROW);
		  break;
	}
}

void CLinesView::CalcSize(int cx, int cy) {
	CLinesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	

	if(cx==-1 || cy==-1) {
		RECT rect;
		GetClientRect(&rect);
		cx = rect.right;
		cy = rect.bottom;
	}

	cell_dx = cx / (pDoc->grid.GetWidth()+2);
	cell_dy = cy / (pDoc->grid.GetHeight()+2);
		
	if(m_bSquareCellView) {
		int aux = min(cell_dx, cell_dy);
		cell_dx = cell_dy = aux;
	}

	grid_ox = (cx - (cell_dx*pDoc->grid.GetWidth()) )/2;
	grid_oy = (cy - (cell_dy*pDoc->grid.GetHeight()) )/2;
	


	node_dx = cell_dx/6;
	node_dy = cell_dy/6;


}
