// LinesView.h : interface of the CLinesView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __LINESVIEW__
#define __LINESVIEW__

#include "Grid.h"
#include "Colors.h"
#include "LinesDoc.h"


class CLinesView : public CView
{
protected: // create from serialization only
	CLinesView();
	DECLARE_DYNCREATE(CLinesView)

// Attributes
public:
	void CalcSize(int cx=-1, int cy=-1);
	void SetMyCursor(void);
	void InitDefaultColors(void);
	void WriteINIFile(void);
	BOOL LoadINIFile(void);
	void GetLineCoord(CMLine& line, CPoint * point);

	HCURSOR hCursorP1;
	HCURSOR hCursorP2;
	HCURSOR hCursorP1Again;
	HCURSOR hCursorP2Again;



	CMColors color;
	CMColors near_color;

	BOOL m_bSquareCellView;  // force cells to appear as squares when resizing

	int grid_ox;    // origin of grid
	int grid_oy;    // origin of grid

	int cell_dx;   // distance between two columns
	int cell_dy;   // distance between two rows

	int node_dx;
	int node_dy;

	CLinesDoc* GetDocument();

// Operations
public:
	static CLinesView * GetView();
	void GetPointedLine(CPoint point, CMLine *line);//line.dir=NONE when no line pointed

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLinesView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CLinesView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CLinesView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in LinesView.cpp
inline CLinesDoc* CLinesView::GetDocument()
   { return (CLinesDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////


#endif
