// MColorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Lines.h"
#include "MColorDl.h"
#include "LinesVie.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MColorDlg dialog


MColorDlg::MColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(MColorDlg::IDD, pParent)
{

	Create(IDD_DIALOG_COLOR, pParent);

	ShowWindow(SW_SHOW);

	//{{AFX_DATA_INIT(MColorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void MColorDlg::DoDataExchange(CDataExchange* pDX)
{

	




	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MColorDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MColorDlg, CDialog)
	//{{AFX_MSG_MAP(MColorDlg)
	ON_BN_CLICKED(ID_BACKGROUND, OnBackgroundcolor)
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_PLAYER1, OnPlayer1)
	ON_BN_CLICKED(ID_PLAYER2, OnPlayer2)
	ON_BN_CLICKED(ID_UNCHECKED, OnUnchecked)
	ON_BN_CLICKED(ID_NODE_FRAME, OnNodeFrame)
	ON_BN_CLICKED(ID_NODE_FILL, OnNodeFill)
	ON_BN_CLICKED(ID_DEFAULT, OnDefault)
	ON_BN_CLICKED(ID_LINE, OnLine)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MColorDlg message handlers

BOOL MColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CLinesView* pView = CLinesView::GetView();
	ASSERT(pView);
	
	m_colOriginal = pView->color;
	m_colCurrent = &(pView->color);

	m_colLastBackground = m_colOriginal.background;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void MColorDlg::PostNcDestroy() {
	// You should also override PostNcDestroy for modeless dialog boxes 
	// in order to delete this, since modeless dialog boxes are usually
	// allocated with new

	delete this;

	CDialog::PostNcDestroy();
}

void MColorDlg::OnClose() {
	// You should also override OnCancel and call DestroyWindow from within it

	OnCancel();

	// DONT CDialog::OnClose();
}

void MColorDlg::OnCancel() {

	CMenu* pMenu = AfxGetMainWnd()->GetMenu();
	ASSERT(pMenu);
	if(pMenu) pMenu->EnableMenuItem(ID_COLOR, MF_ENABLED);

	CLinesView* pView = CLinesView::GetView();
	ASSERT(pView);

	pView->color = m_colOriginal;

	OnPreview();

//	AfxGetMainWnd()->MessageBox("On Cancel");

	DestroyWindow();
	// DONT CDialog::OnCancel();
}

void MColorDlg::OnOK() {
	
	CMenu* pMenu = AfxGetMainWnd()->GetMenu();
	ASSERT(pMenu);
	if(pMenu) pMenu->EnableMenuItem(ID_COLOR, MF_ENABLED);


	CLinesView* pView = CLinesView::GetView();
	ASSERT(pView);
//	pView->color = m_colCurrent;

//	AfxGetMainWnd()->MessageBox("On OK");

	OnPreview();


	pView->WriteINIFile();

	DestroyWindow();
	// DONT CDialog::OnOK();
}

void MColorDlg::OnPreview() {
	CLinesView* pView = CLinesView::GetView();
	ASSERT(pView);
	
//	pView->color = m_colCurrent;
	if(m_colLastBackground != m_colCurrent->background) {
		m_colLastBackground = m_colCurrent->background;
		pView->Invalidate();
		pView->OnEraseBkgnd(AfxGetMainWnd.GetDC());

	}
	
	pView->OnDraw(pView->GetDC());
	
}



void MColorDlg::OnBackgroundcolor() {
	ChooseColor(&m_colCurrent->background);
}

void MColorDlg::OnLine() {
	ChooseColor(&m_colCurrent->line);
}

void MColorDlg::OnPlayer1() {
	ChooseColor(&m_colCurrent->player1);
}

void MColorDlg::OnPlayer2() {
	ChooseColor(&m_colCurrent->player2);
	
}

void MColorDlg::OnUnchecked() {
	ChooseColor(&m_colCurrent->unchecked);
}

void MColorDlg::OnNodeFrame() {
	ChooseColor(&m_colCurrent->node_frame);
}

void MColorDlg::OnNodeFill() { 
	ChooseColor(&m_colCurrent->node_fill); 
}


void MColorDlg::ChooseColor(COLORREF* color) {

	CColorDialog cd;
	
	if(cd.DoModal() == IDOK) {
		*color = cd.GetColor();
	}

	OnPreview();

}

void MColorDlg::OnDefault() {
	CLinesView* pView = CLinesView::GetView();
	ASSERT(pView);

	pView->InitDefaultColors();
	
	OnPreview();
}




