#include "TryGrid.h"



void CMTryGrid::TryAllLines(CMGrid& grid) {

	CMLine line;
	
	n_try = 0;

	ASSERT(RIGHT==1);
	ASSERT(DOWN==2);

	for(line.y=0; line.y<grid.GetHeight()+1; line.y++) {
		for(line.x=0; line.x<grid.GetWidth()+1; line.x++) {

			if(line.x<grid.GetWidth()) {
				line.dir=RIGHT;
				TryLine(grid, line);
			}
				
			if(line.y<grid.GetHeight()) {
				line.dir=DOWN;
				TryLine(grid, line);
			}
			
		}
	}

//	char str[200];
//	sprintf(str, "n_try = %i  ", n_try);
//	AfxGetMainWnd()->MessageBox(str);

	ASSERT(n_try);

}


void CMTryGrid::TryLine(CMGrid& grid, CMLine& line) {
	
	t_grid = grid;

	if(t_grid.IsLineSet(line) == FALSE) {

		t_grid.SetLine(line, PLAYER1);
			
		ASSERT(n_try<=MAX_GRID_ALLOC * MAX_GRID_ALLOC);

		t_grid.GetCount(&t_count[n_try]);
		t_line[n_try] = line;
		n_try++;
	}

}




BOOL CMTryGrid::AnyDontMakeThree(void) {
	
	//int count = 0;

	ASSERT(n_try>=0 && n_try<MAX_GRID_ALLOC * MAX_GRID_ALLOC);

	for(int i=0; i<n_try; i++) {
		if(t_count[i].threes==0) return TRUE;//count++;
	}


	return FALSE;
	//return (count!=n_try);
}




void CMTryGrid::ChooseOneWhichDontMakeThree(CMLine *chosen_line) {

	int i0 = random(n_try);
	int i=i0;

	BOOL done = FALSE;

	do {
		ASSERT(i>=0 && i<n_try);   // out of range
		
		if(t_count[i].threes==0) {
			*chosen_line = t_line[i];
			done = TRUE;
		}

		i++; 
		if(i >= n_try) i=0;

		ASSERT(done || i!=i0);  // endless loop

	} while(!done);




}


void CMTryGrid::ChooseLessHarming(CMGrid& grid, CMLine* chosen_line) {
	int min_n_cells = 9999;
	int n_cells;

	for(int i=0; i<n_try; i++) {
		//ASSERT(t_count[i].threes==0; ???????
		n_cells = CalcHarm(grid, t_line[i]);
		if(n_cells<min_n_cells) {
			min_n_cells = n_cells;
			*chosen_line = t_line[i];
		}
	}
	
	ASSERT(min_n_cells != 9999);

}

int CMTryGrid::CalcHarm(CMGrid& grid, CMLine& line) {
	CMLine aux_line;
	int lost_cells = 0;
	CMGrid aux_grid;
	st_count aux_count;

	aux_grid = grid;
	aux_line = line;

	for(;;) {
		aux_grid.SetLine(aux_line, PLAYER1);
		aux_grid.GetCount(&aux_count);

		if(aux_grid.AnyMakeFour()) {
			lost_cells++;
			aux_grid.GetMakeFour(&aux_line);
		}
		else return lost_cells;
	}

}
